package NameCache {
	function startGame ()
	{
		Parent::startGame();

		if(isFile("config/server/nameCache.cs"))
			exec("config/server/nameCache.cs");
	}

	function ServerLoadSaveFile_End() {
		Parent::ServerLoadSaveFile_End();
		
		if(!$Server::LAN) {
			if(isFile("config/server/nameCache.cs"))
				exec("config/server/nameCache.cs");

			for(%i = 0; %i < MainBrickGroup.getCount(); %i++) {
				%brickgroup = MainBrickGroup.getObject(%i);
				if(%brickgroup.name $= ("\c1BL_ID: " @ %brickgroup.bl_id @ "\c0") && $Server::NameCache[%brickgroup.bl_id] !$= "") // if brickgroup has default name
					%brickgroup.name = "\c1" @ $Server::NameCache[%brickgroup.bl_id] @ "\c0"; // change name to cached name, but blue
			}
		}
	}
	
	function GameConnection::onClientEnterGame(%this)
	{
		Parent::onClientEnterGame(%this);
		
		if(!$Server::LAN) {
			if($Server::NameCache[%this.getBLID()] !$= %this.getPlayerName()) {
				$Server::NameCache[%this.getBLID()] = %this.getPlayerName();
				export("$Server::NameCache*","config/server/nameCache.cs");
			}
		}
	}
};
activatePackage("NameCache");